## pxe-kexec 0.2.4

=== CMakeLists.txt ===
#
# (c) 2009, Bernhard Walle <bernhard@bwalle.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

PROJECT(pxe-kexec CXX C)

#
# Configuration
#

cmake_minimum_required(VERSION 2.4)
set (PACKAGE_STRING "pxe-kexec")
set (PACKAGE_VERSION "0.2.4")

include_directories("${PROJECT_BINARY_DIR}")

#
# Executable
#
FIND_PROGRAM(POD2MAN_EXECUTABLE pod2man)

#
# Directories
#

set(MANDIR "${CMAKE_INSTALL_PREFIX}/share/man" CACHE
        STRING "Place where the manual page is installed.")

#
# Libraries
#

set (CMAKE_LIBRARY_PATH /usr/lib64 ${CMAKE_LIBRARY_PATH})

# libbw

ADD_SUBDIRECTORY(ext/libbw)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/ext)
SET (EXTRA_LIBS ${EXTRA_LIBS} bw)

# CURL

find_package(CURL REQUIRED)
set (EXTRA_LIBS ${EXTRA_LIBS} ${CURL_LIBRARIES})
include_directories(${CURL_INCLUDE_DIRS})

#
# Configure file
#

configure_file(
    "${PROJECT_SOURCE_DIR}/config.h.in"
    "${PROJECT_BINARY_DIR}/config.h"
)


#
# Subdirs
#

ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(scripts)


#
# Documentation
#


ADD_CUSTOM_TARGET(apidoc
    doxygen
    WORKING_DIRECTORY ${pxe-kexec_SOURCE_DIR}
)

# vim: set sw=4 ts=4 et:

=== scripts/CMakeLists.txt ===
#
# (c) 2009, Bernhard Walle <bernhard@bwalle.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# This is a bit unclean since we test if the directory exists on the host
# system. But well, for people that just install pxe-kexec on their
# machines manually, it works. Packagers can easily copy the script
# in their packaging script. But I don't want to clutter the system
# of people that are using dhcpcd.

IF (EXISTS /etc/dhcp3/dhclient-enter-hooks.d)
    INSTALL(
        PROGRAMS        dhclient-enter-hook-pxe-kexec.sh
        DESTINATION     /etc/dhcp3/dhclient-enter-hooks.d
        RENAME          pxe_kexec
    )
ENDIF (EXISTS /etc/dhcp3/dhclient-enter-hooks.d)

=== src/CMakeLists.txt ===
#
# (c) 2009, Bernhard Walle <bernhard@bwalle.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

add_executable(pxe-kexec
        kexec.cc
        pxeparser.cc
        downloader.cc
        main.cc
        process.cc
        networkhelper.cc
        console.cc
        pxekexec.cc
        linuxdb.cc
        ext/rpmvercmp.c)
target_link_libraries(pxe-kexec ${EXTRA_LIBS})

INSTALL(
    TARGETS
        pxe-kexec
    DESTINATION
        sbin
)

INSTALL(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/pxe-kexec.8.gz
    DESTINATION
        ${MANDIR}/man8
)


ADD_CUSTOM_COMMAND(
    OUTPUT
        ${CMAKE_CURRENT_BINARY_DIR}/pxe-kexec.8.gz
    COMMAND
        ${POD2MAN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pxe-kexec.pod
        --center="PXE-Kexec"
        --release=${PACKAGE_VERSION}
        ${CMAKE_CURRENT_BINARY_DIR}/pxe-kexec.8 &&
        rm -f ${CMAKE_CURRENT_SOURCE_DIR}/pxe-kexec.8.xml &&
        gzip -f ${CMAKE_CURRENT_BINARY_DIR}/pxe-kexec.8
    DEPENDS
        ${CMAKE_CURRENT_SOURCE_DIR}/pxe-kexec.pod
    WORKING_DIRECTORY
        ${CMAKE_CURRENT_BINARY_DIR}
)

#
# always build the manpages before building the program
ADD_DEPENDENCIES(
    pxe-kexec
    manpages
)

#
# we need to make a target out of the two ADD_CUSTOM_COMMAND() calls
# because otherwise cmake ignores the manpages
ADD_CUSTOM_TARGET(
    manpages
    DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/pxe-kexec.8.gz
)

=== ext/libbw/CMakeLists.txt ===
# {{{
# Copyright (c) 2009-2010, Bernhard Walle <bernhard@bwalle.de>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the <organization> nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY <copyright holder> ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. }}}

set (HAVE_LIBREADLINE 0)

# Readline

find_path(READLINE_INCLUDE_DIR readline/readline.h
    NO_DEFAULT_PATH
    PATHS /opt/local/include /usr/local/include /usr/include)
mark_as_advanced(READLINE_INCLUDE_DIR)

find_library(READLINE_LIBRARY readline
    /opt/local/lib /usr/lib64 /usr/lib)
mark_as_advanced(READLINE_LIBRARY)

if (READLINE_LIBRARY AND READLINE_INCLUDE_DIR)
    include_directories( ${READLINE_INCLUDE_DIR} )
    set (EXTRA_LIBS ${EXTRA_LIBS} ${READLINE_LIBRARY})
    set (HAVE_LIBREADLINE 1)
endif (READLINE_LIBRARY AND READLINE_INCLUDE_DIR)

if (NOT CURSES_LIBRARIES)
    find_package(Curses REQUIRED)
endif (NOT CURSES_LIBRARIES)

set (EXTRA_LIBS ${EXTRA_LIBS} ${CURSES_LIBRARIES})
include_directories( ${CURSES_INCLUDE_DIR} )

# do we have a proper getopt_long() implementation

include(CheckFunctionExists)

set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
set(CMAKE_REQUIRED_INCLUDES "getopt.h")
check_function_exists("getopt_long" HAVE_GETOPT_LONG)
unset(CMAKE_REQUIRED_DEFINITIONS)
unset(CMAKE_REQUIRED_INCLUDES)

# for bwconfig.h
include_directories( ${CMAKE_CURRENT_BINARY_DIR} )

set(LIBBW_SRCS
    debug.h
    debug.cc
    stringutil.h
    stringutil.cc
    completion.h
    completion.cc
    bwerror.h
    optionparser.h
    optionparser.cc
)

if (CMAKE_HOST_UNIX)
    set(LIBBW_SRCS
        ${LIBBW_SRCS}
        serialfile.h
        serialfile_posix.cc
    )
endif (CMAKE_HOST_UNIX)

# link our own version of getopt_long() if the system doesn't provide a
# suitable one
if (NOT HAVE_GETOPT_LONG)
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/ext/getopt")
    set(LIBBW_SRCS
        ${LIBBW_SRCS}
        ext/getopt/getopt.c
        ext/getopt/getopt.h
        ext/getopt/getopt_long.c
    )
endif (NOT HAVE_GETOPT_LONG)

add_library(
    bw
    STATIC
    ${LIBBW_SRCS}
)

target_link_libraries(
    bw
    ${EXTRA_LIBS}
)

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/bwconfig.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/bwconfig.h"
)

# vim: set sw=4 ts=4 et fdm=marker:

=== debian/changelog ===
pxe-kexec (0.2.4-3build1) yakkety; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 17 Sep 2016 12:07:56 +0000

pxe-kexec (0.2.4-3) unstable; urgency=low

  * debian/patches/fix-ftbfs-gcc-4-7.patch: Resolve FTBFS when built with
    gcc-4.7.  Adds an additional 'include' of 'unistd.h' to
    src/networkhelper.cc. Patch courtesy of Paul Tagliamonte. (Closes: #672071)
  * debian/control: Bumped standards to 3.9.3, no changes required.
  * debian/copyright: Updated Format URL to new (versioned) location.

 -- Dave Walker (Daviey) <DaveWalker@ubuntu.com>  Mon, 14 May 2012 09:13:15 +0100

pxe-kexec (0.2.4-2) unstable; urgency=low

  * debian/control: 
    - Only build for linux-any.
    - Added kexec-tools to Build-Depends to ensure there is a
      published binary for that target architecture.

 -- Dave Walker (Daviey) <DaveWalker@ubuntu.com>  Wed, 07 Dec 2011 13:49:07 +0000

pxe-kexec (0.2.4-1) unstable; urgency=low

  * Initial release (Closes: #649338)

 -- Dave Walker (Daviey) <DaveWalker@ubuntu.com>  Sat, 19 Nov 2011 18:41:34 +0000

=== debian/control ===
Source: pxe-kexec
Section: admin
Priority: extra
Maintainer: Dave Walker (Daviey) <DaveWalker@ubuntu.com>
Build-Depends: cmake,
               debhelper (>= 8),
               kexec-tools,
               libcurl4-gnutls-dev,
               libncurses5-dev,
               libreadline-dev
Standards-Version: 3.9.3
Homepage: http://developer.berlios.de/projects/pxe-kexec/

Package: pxe-kexec
Architecture: linux-any
Depends: kexec-tools, ${misc:Depends}, ${shlibs:Depends}
Description: Fetch PXE configuration file and netboot using kexec
 Tool that fetches PXE configuration file (SysLinux' PXELinux format),
 prompts the user for a boot entry (label), (supports interactive
 editing of the kernel parameters), downloads the selected kernel and
 initrd over the network using TFTP, FTP or HTTP and finally reboots
 into the kernel using kexec.

=== debian/watch ===
version=3

opts=downloadurlmangle=s/prdownload/download/ \
http://developer.berlios.de/project/showfiles.php?group_id=10432 \
http://prdownload.berlios.de/pxe-kexec/pxe-kexec-(.*)\.tar\.bz2
